<template>
  <el-bus-crud v-bind="tableConfig" />
</template>

<script>
import { couponForm, couponSearchForm, couponColumn } from '@/utils/coupon-form'
export default {
  data() {
    return {
      tableConfig: {
        url: 'flower/api/v2/coupon/vip/page',
        newUrl: 'flower/api/v2/coupon/vip',
        viewUrl: 'flower/api/v2/coupon/vip',
        viewOnPath: true,
        editUrl: 'flower/api/v2/coupon/vip',
        editMethodType: 'put',
        editOnPath: true,
        deleteUrl: 'flower/api/v2/coupon/vip',
        deleteMethodType: 'delete',
        deleteOnPath: true,
        onResetView: (row) => {
          this.$router.push(`${this.$route.path}/${row.id}`)
        },
        operationAttrs: {
          width: 140,
          fixed: 'right',
        },
        columns: [
          ...couponColumn(),
          { label: '会员等级', prop: 'memberName' },
          {
            label: '有效期',
            formatter: (row) =>
              row.usageStartDate
                ? `${row.usageStartDate || ''} ~ ${row.usageEndDate || ''}`
                : '',
            minWidth: 320,
          },
          { label: '已发放数量', prop: 'getNum', minWidth: 120 },
          { label: '操作人', prop: 'createByName', minWidth: 120 },
        ],
        searchForm: [
          {
            type: 'row',
            items: [...couponSearchForm()],
          },
        ],
        form: [
          {
            label: '会员等级：',
            id: 'memberId',
            type: 'bus-select',
            el: {
              interfaceUri: 'flower/api/member/list',
              props: {
                label: 'name',
                value: 'id',
                dataPath: 'records',
              },
              extraQuery: {
                current: 1,
                size: 2000,
              },
              filterable: true,
              style: 'width:100%',
            },
            rules: { required: true, message: '请选择会员等级' },
          },
          ...couponForm(),
        ],
      },
    }
  },
  head() {
    return {
      title: '会员优惠券',
    }
  },
}
</script>
